Subject: [PATCH v4] can: xilinx CAN controller support.

From: [email-masked] (Marc Kleine-Budde)
Date: Fri, 28 Feb 2014 14:32:22 +0100

On 02/28/2014 02:27 PM, Appana Durga Kedareswara Rao wrote:

>> -----Original Message-----
>> From: Marc Kleine-Budde [mailto:mkl at pengutronix.de]
>> Sent: Friday, February 28, 2014 6:45 PM
>> To: Appana Durga Kedareswara Rao; wg at grandegger.com; Michal Simek;
>> grant.likely at linaro.org; robh+dt at kernel.org; linux-can at vger.kernel.org
>> Cc: netdev at vger.kernel.org; linux-arm-kernel at lists.infradead.org; linux-
>> kernel at vger.kernel.org; devicetree at vger.kernel.org
>> Subject: Re: [PATCH v4] can: xilinx CAN controller support.
>>
>> On 02/28/2014 02:07 PM, Appana Durga Kedareswara Rao wrote:
>>>>>> What happens if the interrupt handler is delayed? For example in a
>>>>>> RT enabled system the interrupt handler runs as a thread. There
>>>>>> might be other threads with higher priority. The hardware will
>>>>>> probably send all CAN frames in the FIFO, so you want to reduce the
>>>>>> overhead and loop in the tx complete handler.
>>>>>>
>>>>> Yes I agree with your comment.
>>>>> It will be good to have a loop in the Tx interrupt handler I am
>>>>> modifying the Tx interrupt handler like below.
>>>>>
>>>>> static void xcan_tx_interrupt(struct net_device *ndev, u32 isr) {
>>>>>         struct xcan_priv *priv = netdev_priv(ndev);
>>>>>         struct net_device_stats *stats = &ndev->stats;
>>>>>
>>>>>         while (priv->tx_head - priv->tx_tail > 0) {
>>>>>                 if (!(isr & XCAN_IXR_TXOK_MASK)) {
>>>>>                         break;
>>>>>                 }
>>>>>                 can_get_echo_skb(ndev, priv->tx_tail %
>>>>>                                         priv->xcan_echo_skb_max_tx);
>>>>>                 priv->tx_tail++;
>>>>>                 stats->tx_packets++;
>>>>>                 can_led_event(ndev, CAN_LED_EVENT_TX);
>>
>> Probably first clear the interrupt, because you've just handled it, then check
>> if it's still present. The question is, do you have to clear the IRQ for each
>> transmitted frame, or does one clean of the interrupt clear the bit for more
>> then one transmitted frame?
>>
> 
> We already were clearing it in the interrupt routine
> (xcan_interrupt). That's why clearing it at the end of the loop. We
> have to clear the IRQ (TXOK) for each transmitted frame.

Please move the clear into the loop. Then it's all in one place. Good
that you have to clear the bit for each transmitted frame. I think,
we're almost done :) When I'm okay with the driver, let Wolfgang have a
look at the error handling.

Marc

-- 
Pengutronix e.K.                  | Marc Kleine-Budde           |
Industrial Linux Solutions        | Phone: +49-231-2826-924     |
Vertretung West/Dortmund          | Fax:   +49-5121-206917-5555 |
Amtsgericht Hildesheim, HRA 2686  | http://www.pengutronix.de   |

-------------- next part --------------
A non-text attachment was scrubbed...
Name: signature.asc
Type: application/pgp-signature
Size: 242 bytes
Desc: OpenPGP digital signature
URL: <http://lists.infradead.org/pipermail/linux-arm-kernel/attachments/20140228/1e898ac5/attachment.sig>